//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "epw30api.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

//for Dump Command
#define MODE_BYTE	0
#define MODE_LITTLE	1
#define MODE_BIG	2

//Device Size (BYTE)
#define D93C46_SIZE		128
#define D24C02_SIZE 	256
#define D25C020_SIZE	256

byte DataBuff[256];	//Read Write Buffer


//---------------------------------------------------------------------------
void TForm1::Dump(byte *buf,int cnt,int endian)
{
	//endian=-1 normal dump
	//      =0	byte mode
	//      =1  little endian
	//		=2  Big Endian
	int lcnt=0;
	int adr=0;
	AnsiString lstr,wstr;

	while(cnt>=16){
		switch(endian){
		case MODE_BYTE:
			//0-7
			lstr.printf("%05X:%02X %02X %02X %02X %02X %02X %02X %02X-",
				adr,buf[0],buf[1],buf[2],buf[3],buf[4],buf[5],buf[6],buf[7]);
			//8-15
			buf+=8;
			wstr.printf("%02X %02X %02X %02X %02X %02X %02X %02X\n",
				buf[0],buf[1],buf[2],buf[3],buf[4],buf[5],buf[6],buf[7]);
			lstr+=wstr;
			adr+=16;
			break;
		case MODE_LITTLE:
			//0-7
			lstr.printf("%05X:%02X%02X %02X%02X %02X%02X %02X%02X-",
				adr,buf[1],buf[0],buf[3],buf[2],buf[5],buf[4],buf[7],buf[6]);
			//8-15
			buf+=8;
			wstr.printf("%02X%02X %02X%02X %02X%02X %02X%02X\n",
				buf[1],buf[0],buf[3],buf[2],buf[5],buf[4],buf[7],buf[6]);
			lstr+=wstr;
			adr+=8;
			break;
		case MODE_BIG:
			//0-7
			lstr.printf("%05X:%02X%02X %02X%02X %02X%02X %02X%02X-",
				adr,buf[0],buf[1],buf[2],buf[3],buf[4],buf[5],buf[6],buf[7]);
			//8-15
			buf+=8;
			wstr.printf("%02X%02X %02X%02X %02X%02X %02X%02X\n",
				buf[0],buf[1],buf[2],buf[3],buf[4],buf[5],buf[6],buf[7]);
			lstr+=wstr;
			adr+=8;
			break;
		default:
			//0-7
			lstr.printf("%02X %02X %02X %02X %02X %02X %02X %02X-",
				buf[0],buf[1],buf[2],buf[3],buf[4],buf[5],buf[6],buf[7]);
			//8-15
			buf+=8;
			wstr.printf("%02X %02X %02X %02X %02X %02X %02X %02X\n",
				buf[0],buf[1],buf[2],buf[3],buf[4],buf[5],buf[6],buf[7]);
			lstr+=wstr;

		}
		Memo->Lines->Add(lstr);
		buf+=8;
		cnt-=16;
	}
	if(cnt<=0)
		return;

	lcnt=0;
	if(endian>=0){
		lstr.printf("%05X",adr);
	}else{
		lstr="";
	}
	while(cnt>0){
		switch(endian){
		case MODE_LITTLE:
			if(lcnt==6)
				wstr.printf("%02X%02X-",buf[0],buf[1]);
			else
				wstr.printf("%02X%02X ",buf[0],buf[1]);
			lstr+=wstr;
			buf+=2;
			cnt-=2;
			lcnt+=2;
			break;
		case MODE_BIG:
			if(lcnt==6)
				wstr.printf("%02X%02X-",buf[1],buf[0]);
			else
				wstr.printf("%02X%02X ",buf[1],buf[0]);
			lstr+=wstr;
			buf+=2;
			cnt-=2;
			lcnt+=2;
			break;
		default:
			if(lcnt==7)
				wstr.printf("%02X-",buf[0]);
			else
				wstr.printf("%02X ",buf[0]);
			lstr+=wstr;
			buf++;
			cnt--;
			lcnt++;
		}
	}
	Memo->Lines->Add(lstr);
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ClearButtonClick(TObject *Sender)
{
	Memo->Lines->Clear();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ReadButtonClick(TObject *Sender)
{
	int devtype[3]={D93C46,D24C02,D25C020};
	int romsize[3]={D93C46_SIZE,D24C02_SIZE,D25C020_SIZE};
	int devmode=DeviceSelect->ItemIndex;	//0:MCW,1:I2C,2:SPI
	int endian;

	if(!EpwOpen(devmode,0,50,FALSE)){	//ExtMode=default,WriteTime=50ms
		Memo->Lines->Add("ڑs");
		return;
	}
	if(!EpwCheck()){
		Memo->Lines->Add("foCX܂B");
		EpwClose();
		return;
	}
	Memo->Lines->Add("ڑ");


	if(!EpwRead(devtype[devmode],0,DataBuff,romsize[devmode],0)){	//Address=0,PgaeSize=0(AUTO)
		Memo->Lines->Add("ǏoG[܂B");
	}else{
		if(devmode==T_MCW)
			endian=MODE_BIG;
		else
			endian=MODE_BYTE;
		Dump(DataBuff,romsize[devmode],endian);
		Memo->Lines->Add("Ǐo");
	}

	EpwClose();
	Memo->Lines->Add("ؒf");

}
//---------------------------------------------------------------------------
void __fastcall TForm1::WriteButtonClick(TObject *Sender)
{
	int devtype[3]={D93C46,D24C02,D25C020};
	int romsize[3]={D93C46_SIZE,D24C02_SIZE,D25C020_SIZE};
	int devmode=DeviceSelect->ItemIndex;	//0:MCW,1:I2C,2:SPI
	int i,endian,page;

	if(!EpwOpen(devmode,0,50,FALSE)){	//ExtMode=default,WriteTime=50ms
		Memo->Lines->Add("ڑs");
		return;
	}
	if(!EpwCheck()){
		Memo->Lines->Add("foCX܂B");
		EpwClose();
		return;
	}
	Memo->Lines->Add("ڑ");


	if(devmode==T_MCW){
		endian=MODE_BIG;
		page=2;
	}else{
		endian=MODE_BYTE;
		page=1;
	}
	for(i=0;i<romsize[devmode];i++){
		DataBuff[i]=i;
	}
	Memo->Lines->Add("݃f[^:");
	Dump(DataBuff,romsize[devmode],endian);
	if(!EpwWrite(devtype[devmode],0,DataBuff,romsize[devmode],page)){ //Address=0
		Memo->Lines->Add("݃G[܂B");
	}else{
		Memo->Lines->Add("݊");
	}
	EpwClose();
	Memo->Lines->Add("ؒf");

}
//---------------------------------------------------------------------------

void __fastcall TForm1::EraseButtonClick(TObject *Sender)
{
	int devtype[3]={D93C46,D24C02,D25C020};
	int romsize[3]={D93C46_SIZE,D24C02_SIZE,D25C020_SIZE};
	int devmode=DeviceSelect->ItemIndex;	//0:MCW,1:I2C,2:SPI
	int i,endian,page;

	if(!EpwOpen(devmode,0,50,FALSE)){	//ExtMode=default,WriteTime=50ms
		Memo->Lines->Add("ڑs");
		return;
	}
	if(!EpwCheck()){
		Memo->Lines->Add("foCX܂B");
		EpwClose();
		return;
	}
	Memo->Lines->Add("ڑ");


	if(devmode==T_MCW){
		endian=MODE_BIG;
		page=2;
	}else{
		endian=MODE_BYTE;
		page=1;
	}
	if(!EpwErase(devtype[devmode],0,DataBuff,romsize[devmode],page)){ //Address=0
		Memo->Lines->Add("G[܂B");
	}else{
		Memo->Lines->Add("f[^܂B");
	}
	EpwClose();
	Memo->Lines->Add("ؒf");
}
//---------------------------------------------------------------------------

