﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;




namespace EPW30DllSample {
    public partial class Form1 : Form {
        [System.Runtime.InteropServices.DllImport("epw30udll.dll", CallingConvention = System.Runtime.InteropServices.CallingConvention.Cdecl)]
        extern static bool _EpwOpen(int mode, int extmode, int writetime,bool ExtPower);
        [System.Runtime.InteropServices.DllImport("epw30udll.dll", CallingConvention = System.Runtime.InteropServices.CallingConvention.Cdecl)]
        extern static void _EpwClose();
        [System.Runtime.InteropServices.DllImport("epw30udll.dll", CallingConvention = System.Runtime.InteropServices.CallingConvention.Cdecl)]
        extern static bool _EpwMode(int mode, int extmode, int writetime);
        [System.Runtime.InteropServices.DllImport("epw30udll.dll", CallingConvention = System.Runtime.InteropServices.CallingConvention.Cdecl)]
        extern static int _EpwCheck();
        [System.Runtime.InteropServices.DllImport("epw30udll.dll", CallingConvention = System.Runtime.InteropServices.CallingConvention.Cdecl)]
        extern static bool _EpwRead(int type, int adr, byte[] dat, int len, int psize);
        [System.Runtime.InteropServices.DllImport("epw30udll.dll", CallingConvention = System.Runtime.InteropServices.CallingConvention.Cdecl)]
        extern static bool _EpwCompare(int type, int adr, byte[] dat, int len, int psize);
        [System.Runtime.InteropServices.DllImport("epw30udll.dll", CallingConvention = System.Runtime.InteropServices.CallingConvention.Cdecl)]
        extern static int _EpwChecksum(int type, int adr, byte[] dat, int len, int psize);
        [System.Runtime.InteropServices.DllImport("epw30udll.dll", CallingConvention = System.Runtime.InteropServices.CallingConvention.Cdecl)]
        extern static bool _EpwBlankChk(int type, int adr, byte[] dat, int len, int psize);
        [System.Runtime.InteropServices.DllImport("epw30udll.dll", CallingConvention = System.Runtime.InteropServices.CallingConvention.Cdecl)]
        extern static bool _EpwWrite(int type, int adr, byte[] dat, int len, int psize);
        [System.Runtime.InteropServices.DllImport("epw30udll.dll", CallingConvention = System.Runtime.InteropServices.CallingConvention.Cdecl)]
        extern static bool _EpwErase(int type, int adr, byte[] dat, int len, int psize);
        [System.Runtime.InteropServices.DllImport("epw30udll.dll", CallingConvention = System.Runtime.InteropServices.CallingConvention.Cdecl)]
        extern static int _EpwDllVer();
        [System.Runtime.InteropServices.DllImport("epw30udll.dll", CallingConvention = System.Runtime.InteropServices.CallingConvention.Cdecl)]
        extern static int _EpwFrmVer();
        [System.Runtime.InteropServices.DllImport("epw30udll.dll", CallingConvention = System.Runtime.InteropServices.CallingConvention.Cdecl)]
        extern static bool _EpwSetFreq(int freq);
        [System.Runtime.InteropServices.DllImport("epw30udll.dll", CallingConvention = System.Runtime.InteropServices.CallingConvention.Cdecl)]
        extern static int _EpwGetFreq();
        [System.Runtime.InteropServices.DllImport("epw30udll.dll", CallingConvention = System.Runtime.InteropServices.CallingConvention.Cdecl)]
        extern static int _EpwGetSwitch();
        [System.Runtime.InteropServices.DllImport("epw30udll.dll", CallingConvention = System.Runtime.InteropServices.CallingConvention.Cdecl)]
        extern static void _EpwSetEvent(int evt);
        [System.Runtime.InteropServices.DllImport("epw30udll.dll", CallingConvention = System.Runtime.InteropServices.CallingConvention.Cdecl)]
        extern static void _EpwReset();
        [System.Runtime.InteropServices.DllImport("epw30udll.dll", CallingConvention = System.Runtime.InteropServices.CallingConvention.Cdecl)]
        extern static int _EpwVpp();
        [System.Runtime.InteropServices.DllImport("epw30udll.dll", CallingConvention = System.Runtime.InteropServices.CallingConvention.Cdecl)]
        extern static bool _EpwDWrite(int mode, byte[] dat, int len);
        [System.Runtime.InteropServices.DllImport("epw30udll.dll", CallingConvention = System.Runtime.InteropServices.CallingConvention.Cdecl)]
        extern static bool _EpwDRead(int mode, byte[] dat, int len);


        const int MODE_BYTE = 0;
        const int MODE_LITTLE = 1;
        const int MODE_BIG = 2;

        const int T_MCW = 0;
        const int T_I2C = 0;
        const int T_SPI = 0;

        byte[] DataBuff=new byte[256];	//Read Write Buffer

        public Form1()
        {
            InitializeComponent();
            rbMCW.Select();
        }

        void Dump(byte[]dat,int len,int endian)
        {
            int tdat,adr,lcnt;
            String lstr;
            adr = 0;
            while (adr < len) {
                lcnt = 0;
                lstr = adr.ToString("X4")+": ";
                for (lcnt = 0; lcnt < 8; lcnt++) {
                    switch (endian) {
                    case MODE_BYTE:
                        tdat = dat[adr];
                        lstr += tdat.ToString("X2")+" ";
                        tdat = dat[adr + 1];
                        lstr += tdat.ToString("X2") + " ";
                        break;
                    case MODE_LITTLE:
                        tdat = dat[adr + 1] * 256 + dat[adr];
                        lstr += tdat.ToString("X4") + " ";
                        break;
                    case MODE_BIG:
                        tdat = dat[adr] * 256 + dat[adr + 1];
                        lstr += tdat.ToString("X4") + " ";
                        break;
                    }
                    if (lcnt == 3) {
                        lstr += "- ";
                    }
                    adr += 2;
                }
                Mes(lstr);
            }

        }

        int GetSelectDevice()
        {
            var RadioButtonChecked_InGroup = DeviceSelect.Controls.OfType<RadioButton>()
                   .SingleOrDefault(rb => rb.Checked == true);

            // 結果
            switch (RadioButtonChecked_InGroup.Name) {
                case "rbMCW":
                    return 0;
                case "rbI2C":
                    return 1;
                case "rbSPI":
                    return 2;

            }
            return -1;
        }

        private void Mes(String str)
        {
            Memo.Text = Memo.Text + str+"\r\n";

        }
        private void ClearButton_Click(object sender, EventArgs e)
        {
            Memo.Text = "";
        }

        private void ReadButton_Click(object sender, EventArgs e)
        {
            //Read
            int[] devtype=new int[3]{ 1,2,1 }; //D93C46,D24C02,D25C020
            int[] romsize = new int[3] { 128, 256, 256 };   // D93C46_SIZE, D24C02_SIZE, D25C020_SIZE 
            int devmode = GetSelectDevice();    //0:MCW,1:I2C,2:SPI
            int endian;

            if (!_EpwOpen(devmode, 0, 50,false)) {    //ExtMode=default,WriteTime=50ms
                Mes("接続失敗");
                return;
            }
            if (_EpwCheck()==0) {
                Mes("デバイスが見つかりません。");
                _EpwClose();
                return;
            }
            Mes("接続成功");

            if (!_EpwRead(devtype[devmode], 0, DataBuff, romsize[devmode], 0)) { //Address=0,PgaeSize=0(AUTO)
                Mes("読出しエラーが発生しました。");
            } else {
                if (devmode == T_MCW)
                    endian = MODE_BIG;
                else
                    endian = MODE_BYTE;
                Dump(DataBuff, romsize[devmode], endian);
                Mes("読出し完了");
            }

            _EpwClose();
            Mes("切断完了");
        }

        private void Writebutton_Click(object sender, EventArgs e)
        {
            //Write
            int[] devtype = new int[3] { 1, 2, 1 }; //D93C46,D24C02,D25C020
            int[] romsize = new int[3] { 128, 256, 256 };   // D93C46_SIZE, D24C02_SIZE, D25C020_SIZE 
            int devmode = GetSelectDevice();    //0:MCW,1:I2C,2:SPI
            int i,endian,page;

            if (!_EpwOpen(devmode, 0, 50, false)) {    //ExtMode=default,WriteTime=50ms
                Mes("接続失敗");
                return;
            }
            if (_EpwCheck() == 0) {
                Mes("デバイスが見つかりません。");
                _EpwClose();
                return;
            }
            Mes("接続成功");

            if (devmode == T_MCW) {
                endian = MODE_BIG;
                page = 2;
            } else {
                endian = MODE_BYTE;
                page = 1;
            }
            for (i = 0; i < romsize[devmode]; i++) {
                DataBuff[i] = (byte)i;
            }
            Mes("書き込みデータ:");
            Dump(DataBuff, romsize[devmode], endian);
            if (!_EpwWrite(devtype[devmode], 0, DataBuff, romsize[devmode], page)) { //Address=0
                Mes("書き込みエラーが発生しました。");
            } else {
                Mes("書き込み完了");
            }
            _EpwClose();
            Mes("切断完了");
        }

        private void Erasebutton_Click(object sender, EventArgs e)
        {
            //Erase
            int[] devtype = new int[3] { 1, 2, 1 }; //D93C46,D24C02,D25C020
            int[] romsize = new int[3] { 128, 256, 256 };   // D93C46_SIZE, D24C02_SIZE, D25C020_SIZE 
            int devmode = GetSelectDevice();    //0:MCW,1:I2C,2:SPI
            int page;

            if (!_EpwOpen(devmode, 0, 50, false)) {    //ExtMode=default,WriteTime=50ms
                Mes("接続失敗");
                return;
            }
            if (_EpwCheck() == 0) {
                Mes("デバイスが見つかりません。");
                _EpwClose();
                return;
            }
            Mes("接続成功");
            if (devmode == T_MCW) {
                page = 2;
            } else {
                page = 1;
            }
            if (!_EpwErase(devtype[devmode], 0, DataBuff, romsize[devmode], page)) { //Address=0
                Mes("消去エラーが発生しました。");
            } else {
                Mes("消去完了");
            }
            _EpwClose();
            Mes("切断完了");

        }
    }
}
