//	epw30api.h =================================================================
//	header file for EPW-30U/EPW-30S/EPW-ISP DLL (C++Builder XE Version)
// =============================================================================
#ifndef _EPW_30_API_H_
#define _EPW_30_API_H_

// DLL Export API ==============================================================
extern "C" __declspec(dllimport) BOOL EpwOpen(int mode,int extmode,int writetime,BOOL ExtPower);
extern "C" __declspec(dllimport) void EpwClose(void);
extern "C" __declspec(dllimport) BOOL EpwMode(int mode,int extmode,int writetime);
extern "C" __declspec(dllimport) int EpwCheck(void);
extern "C" __declspec(dllimport) BOOL EpwRead(int type,int adr,char *dat,int len,int psize);
extern "C" __declspec(dllimport) BOOL EpwCompare(int type,int adr,char *dat,int len,int psize);
extern "C" __declspec(dllimport) int  EpwChecksum(int type,int adr,char *dat,int len,int psize);
extern "C" __declspec(dllimport) BOOL EpwBlankChk(int type,int adr,char *dat,int len,int psize);
extern "C" __declspec(dllimport) BOOL EpwWrite(int type,int adr,char *dat,int len,int psize);
extern "C" __declspec(dllimport) BOOL EpwErase(int type,int adr,char *dat,int len,int psize);
//-----
extern "C" __declspec(dllimport) int EpwDllVer(void);
extern "C" __declspec(dllimport) int EpwFrmVer(void);
extern "C" __declspec(dllimport) BOOL EpwSetFreq(int freq);
extern "C" __declspec(dllimport) int EpwGetFreq(void);
extern "C" __declspec(dllimport) int EpwGetSwitch(void);
extern "C" __declspec(dllimport) void EpwSetEvent(HANDLE evt);
extern "C" __declspec(dllimport) void EpwReset(void);
extern "C" __declspec(dllimport) int EpwVpp(void);
extern "C" __declspec(dllexport) BOOL EpwDWrite(int mode,char *dat,int len);
extern "C" __declspec(dllexport) BOOL EpwDRead(int mode,char *dat,int len);

//Microwire Device ===========
#define D93C06	0
#define D93C46	1
#define D93C56	2
#define D93C57	3
#define D93C66	4
#define D93C76	5
#define D93C86	6
#define D93C06B	100
#define D93C46B	101
#define D93C56B	102
#define D93C57B	103
#define D93C66B	105
#define D93C76B	106
#define D93C86B	106
#define D9010	200
#define D9020	201
#define D9040	202
#define D9080	203
#define D9016	204

//I2C Device ================
#define D24C00	0
#define D24C01	1
#define D24C02	2
#define D24C04	3
#define D24C08	4
#define D24C16	5
#define D24C32	6
#define D24C64	7

//SPI Device ================
#define D25C010	0
#define D25C020	1
#define D25C040	2
#define D25C080	3
#define D25C160	4
#define D25C320	5
#define D25C640	6


#define T_MCW	0
#define T_I2C	1
#define T_SPI	2
#define T_NOTYPE	-1

#define EXT_DEFAULT	0
#define EXT_9000	1


#endif	// _EPW_30_API_H_
