// EPW30DllSampleDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "EPW30DllSample.h"
#include "EPW30DllSampleDlg.h"
#include "epw30api.h"
#include  <stdio.h>
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//for Dump Command
#define MODE_BYTE	0
#define MODE_LITTLE	1
#define MODE_BIG	2

//Device Size (BYTE)
#define D93C46_SIZE		128
#define D24C02_SIZE 	256
#define D25C020_SIZE	256

byte DataBuff[256];	//Read Write Buffer

//---------------------------------------------------------------------------
void CEPW30DllSampleDlg::Dump(byte *buf,int cnt,int endian)
{
	//endian=-1 normal dump
	//      =0	byte mode
	//      =1  little endian
	//		=2  Big Endian
	int lcnt=0;
	int adr=0;
	char lstr[256];
	char wstr[256];

	while(cnt>=16){
		switch(endian){
		case MODE_BYTE:
			//0-7
			sprintf(lstr,"%05X:%02X %02X %02X %02X %02X %02X %02X %02X-",
				adr,buf[0],buf[1],buf[2],buf[3],buf[4],buf[5],buf[6],buf[7]);
			//8-15
			buf+=8;
			sprintf(wstr,"%02X %02X %02X %02X %02X %02X %02X %02X\n",
				buf[0],buf[1],buf[2],buf[3],buf[4],buf[5],buf[6],buf[7]);
			strcat(lstr,wstr);
			adr+=16;
			break;
		case MODE_LITTLE:
			//0-7
			sprintf(lstr,"%05X:%02X%02X %02X%02X %02X%02X %02X%02X-",
				adr,buf[1],buf[0],buf[3],buf[2],buf[5],buf[4],buf[7],buf[6]);
			//8-15
			buf+=8;
			sprintf(wstr,"%02X%02X %02X%02X %02X%02X %02X%02X\n",
				buf[1],buf[0],buf[3],buf[2],buf[5],buf[4],buf[7],buf[6]);
			strcat(lstr,wstr);
			adr+=8;
			break;
		case MODE_BIG:
			//0-7
			sprintf(lstr,"%05X:%02X%02X %02X%02X %02X%02X %02X%02X-",
				adr,buf[0],buf[1],buf[2],buf[3],buf[4],buf[5],buf[6],buf[7]);
			//8-15
			buf+=8;
			sprintf(wstr,"%02X%02X %02X%02X %02X%02X %02X%02X\n",
				buf[0],buf[1],buf[2],buf[3],buf[4],buf[5],buf[6],buf[7]);
			strcat(lstr,wstr);
			adr+=8;
			break;
		default:
			//0-7
			sprintf(lstr,"%02X %02X %02X %02X %02X %02X %02X %02X-",
				buf[0],buf[1],buf[2],buf[3],buf[4],buf[5],buf[6],buf[7]);
			//8-15
			buf+=8;
			sprintf(wstr,"%02X %02X %02X %02X %02X %02X %02X %02X\n",
				buf[0],buf[1],buf[2],buf[3],buf[4],buf[5],buf[6],buf[7]);
			strcat(lstr,wstr);

		}
		Mes(lstr);
		buf+=8;
		cnt-=16;
	}
	if(cnt<=0)
		return;

	lcnt=0;
	if(endian>=0){
		sprintf(lstr,"%05X",adr);
	}else{
		lstr[0]=0;
	}
	while(cnt>0){
		switch(endian){
		case MODE_LITTLE:
			if(lcnt==6)
				sprintf(wstr,"%02X%02X-",buf[0],buf[1]);
			else
				sprintf(wstr,"%02X%02X ",buf[0],buf[1]);
			strcat(lstr,wstr);
			buf+=2;
			cnt-=2;
			lcnt+=2;
			break;
		case MODE_BIG:
			if(lcnt==6)
				sprintf(wstr,"%02X%02X-",buf[1],buf[0]);
			else
				sprintf(wstr,"%02X%02X ",buf[1],buf[0]);
			strcat(lstr,wstr);
			buf+=2;
			cnt-=2;
			lcnt+=2;
			break;
		default:
			if(lcnt==7)
				sprintf(wstr,"%02X-",buf[0]);
			else
				sprintf(wstr,"%02X ",buf[0]);
			strcat(lstr,wstr);
			buf++;
			cnt--;
			lcnt++;
		}
	}
	Mes(lstr);
}
//---------------------------------------------------------------------------/////////////////////////////////////////////////////////////////////////////
// CEPW30DllSampleDlg _CAO

CEPW30DllSampleDlg::CEPW30DllSampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CEPW30DllSampleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEPW30DllSampleDlg)
		// : ̈ʒu ClassWizard ɂăȍǉ܂B
	//}}AFX_DATA_INIT
	// : LoadIcon  Win32  DestroyIcon ̃TuV[PXv܂B
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CEPW30DllSampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEPW30DllSampleDlg)
		// : ̏ꏊɂ ClassWizard ɂ DDX  DDV ̌Ăяoǉ܂B
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CEPW30DllSampleDlg, CDialog)
	//{{AFX_MSG_MAP(CEPW30DllSampleDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_READ_BUTTON, OnReadButton)
	ON_BN_CLICKED(IDC_CLEAR_BUTTON, OnClearButton)
	ON_BN_CLICKED(IDC_WRITE_BUTTON, OnWriteButton)
	ON_BN_CLICKED(IDC_ERASE_BUTTON, OnEraseButton)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEPW30DllSampleDlg bZ[W nh

BOOL CEPW30DllSampleDlg::OnInitDialog()
{
	CFont m_font;
	CDialog::OnInitDialog();

	// ̃_CAOp̃ACRݒ肵܂Bt[[N̓AvP[ṼC
	// EBhE_CAOłȂ͎Iɐݒ肵܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(m_hIcon, FALSE);		// ACRݒ
	
	// TODO: ʂȏs͂̏ꏊɒǉĂB
	CheckRadioButton(IDC_MCW_SELECT,IDC_SPI_SELECT,IDC_MCW_SELECT);
	
	return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
}

// _CAO{bNXɍŏ{^ǉȂ΁AACR`悷
// R[hȉɋLqKv܂BMFC AvP[V document/view
// fgĂ̂ŁȀ̓t[[Nɂ莩Iɏ܂B

void CEPW30DllSampleDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `p̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// NCAg̋`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR`悵܂B
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// VXéA[U[ŏEBhEhbOĂԁA
// J[\\邽߂ɂĂяo܂B
HCURSOR CEPW30DllSampleDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

int CEPW30DllSampleDlg::GetSelectDevice()
{
	int selectID;
	int id;
	selectID=GetCheckedRadioButton(IDC_MCW_SELECT,IDC_SPI_SELECT);
	switch(selectID){
	case IDC_MCW_SELECT:
		id=0;
		break;
	case IDC_I2C_SELECT:
		id=1;
		break;
	case IDC_SPI_SELECT:
		id=2;
		break;
	default:
		id=-1;
	}
	return id;

}

void CEPW30DllSampleDlg::OnReadButton() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	int devtype[3]={D93C46,D24C02,D25C020};
	int romsize[3]={D93C46_SIZE,D24C02_SIZE,D25C020_SIZE};
	int devmode=GetSelectDevice();	//0:MCW,1:I2C,2:SPI
	int endian;

	if(!_EpwOpen(devmode,0,50,FALSE)){	//ExtMode=default,WriteTime=50ms
		Mes("ڑs");
		return;
	}
	if(!_EpwCheck()){
		Mes("foCX܂B");
		_EpwClose();
		return;
	}
	Mes("ڑ");


	if(!_EpwRead(devtype[devmode],0,(char *)DataBuff,romsize[devmode],0)){	//Address=0,PgaeSize=0(AUTO)
		Mes("ǏoG[܂B");
	}else{
		if(devmode==T_MCW)
			endian=MODE_BIG;
		else
			endian=MODE_BYTE;
		Dump(DataBuff,romsize[devmode],endian);
		Mes("Ǐo");
	}

	_EpwClose();
	Mes("ؒf");
}

void CEPW30DllSampleDlg::Mes(CString str)
{
	CString ostr;
	
	((CEdit*)GetDlgItem(IDC_EDIT))->GetWindowText(ostr);
	str=ostr+str+"\r\n";
	((CEdit*)GetDlgItem(IDC_EDIT))->SetWindowText(str);
}

void CEPW30DllSampleDlg::OnClearButton() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CString str;
	
	str="";
	((CEdit*)GetDlgItem(IDC_EDIT))->SetWindowText(str);
}

void CEPW30DllSampleDlg::OnWriteButton() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	int devtype[3]={D93C46,D24C02,D25C020};
	int romsize[3]={D93C46_SIZE,D24C02_SIZE,D25C020_SIZE};
	int devmode=GetSelectDevice();	//0:MCW,1:I2C,2:SPI
	int endian,page,i;

	if(!_EpwOpen(devmode,0,50,FALSE)){	//ExtMode=default,WriteTime=50ms
		Mes("ڑs");
		return;
	}
	if(!_EpwCheck()){
		Mes("foCX܂B");
		_EpwClose();
		return;
	}
	Mes("ڑ");

	if(devmode==T_MCW){
		endian=MODE_BIG;
		page=2;
	}else{
		endian=MODE_BYTE;
		page=1;
	}
	for(i=0;i<romsize[devmode];i++){
		DataBuff[i]=i;
	}
	Mes("݃f[^:");
	Dump(DataBuff,romsize[devmode],endian);
	if(!_EpwWrite(devtype[devmode],0,(char *)DataBuff,romsize[devmode],page)){ //Address=0
		Mes("݃G[܂B");
	}else{
		Mes("݊");
	}
	_EpwClose();
	Mes("ؒf");	
}

void CEPW30DllSampleDlg::OnEraseButton() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	int devtype[3]={D93C46,D24C02,D25C020};
	int romsize[3]={D93C46_SIZE,D24C02_SIZE,D25C020_SIZE};
	int devmode=GetSelectDevice();	//0:MCW,1:I2C,2:SPI
	int page;

	if(!_EpwOpen(devmode,0,50,FALSE)){	//ExtMode=default,WriteTime=50ms
		Mes("ڑs");
		return;
	}
	if(!_EpwCheck()){
		Mes("foCX܂B");
		_EpwClose();
		return;
	}
	Mes("ڑ");

	if(devmode==T_MCW){
		page=2;
	}else{
		page=1;
	}
	if(!_EpwErase(devtype[devmode],0,(char *)DataBuff,romsize[devmode],page)){ //Address=0
		Mes("G[܂B");
	}else{
		Mes("");
	}
	_EpwClose();
	Mes("ؒf");	
}
